/*
 * Copyright 2005-2010 the original author or authors.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ 
/**
 * The authorization package provides an authorization service that can be used to 
 * check whether users have the rights to perform certain operations. 
 * <br/>
 * <img src="doc-files/Class_Diagram__org.wamblee.security.authorization__main.jpg"/>
 * <br/>
 * 
 * {@link AuthorizationService} is the entry point. There is one POJO based implementation 
 * {@link DefaultAuthorizationService}. In addition, there is {@link org.wamblee.security.authorization.jpa.JpaAuthorizationService}
 * which caches an authorization service for efficiency (i.e. {@link DefaultAuthorizationService} is an entity);
 * 
 * The {@link DefaultAuthorizationService} uses a number of authorization rules to determine 
 * whether access allowed. One generic {@link UrlAuthorizationRule} is provided which 
 * determines whether a given user can perform a specific operation for a specific resource
 * type at a specific URL is allowed. 
 * 
 * The authorization service needs to access the current user through the 
 * {@link org.wamblee.security.authentication.UserAccessor} and needs access to the 
 * {@link org.wamblee.security.authentication.UserAdministration} to check whether the 
 * user belongs to certain groups. 
 * 
 */
package org.wamblee.security.authorization;